for ($i=1; $i<10; $i++) {

print "lager fil diffuse$i.vp\n";
open FIL, ">diffuse$i.vp";

$lightsize = $i*3;
$lastlights = 9+$lightsize;


print FIL "!!ARBvp1.0
PARAM const		= program.env[0];
PARAM mvp[4]	= { program.env[1..4] };
PARAM model[3]	= { program.env[5..7] };
PARAM ambient	= program.env[8];
PARAM diffuse	= program.env[9];
PARAM lights[$lightsize]	= { program.env[10..$lastlights] };

ATTRIB pos_obj   = vertex.attrib[0];
ATTRIB norm_obj  = vertex.attrib[2];


TEMP temp;
TEMP norm_world;
TEMP pos_world;
TEMP lightvec;

TEMP totcol;
MOV totcol, ambient;

DP4 pos_world.x, pos_obj, model[0];
DP4 pos_world.y, pos_obj, model[1];
DP4 pos_world.z, pos_obj, model[2];

MOV norm_world, const.x;
DP3 norm_world.x, norm_obj, model[0];
DP3 norm_world.y, norm_obj, model[1];
DP3 norm_world.z, norm_obj, model[2];
DP3 temp.x, norm_world, norm_world;	
RSQ temp.z, temp.x;
RCP temp.x, temp.z;
MUL norm_world, norm_world, temp.z;  # WTF?? det sto temp.x her!!

";

# LIGHTLOOP

for ($j=0; $j<$i; $j++) {
$worldi = ($j*3+0);
$colori = ($j*3+1);
$atteni = ($j*3+2);

print FIL "
SUB lightvec, lights[$worldi], pos_world;
MOV lightvec.w, const.x;

# length of lightvec
DP3 temp.x, lightvec, lightvec;		# length of vector^2
RSQ temp.z, temp.x;					# temp.y <-- 1/length
RCP temp.x, temp.z;					# temp.x <-- length
MUL lightvec, lightvec, temp.z;

# diffuse coeff
DP3 temp.z, lightvec, norm_world;
MAX temp.z, temp.z, const.x;

# atten
SUB temp.y, lights[$atteni].y, temp.x;  # end-length
MUL temp.y, temp.y, lights[$atteni].z;	# (end-length)*slope
MAX temp.y, temp.y, lights[$atteni].x;	# clamp(0, 1.0) - or if no atten: clamp(1.0, 1.0)
MIN temp.y, temp.y, const.z;


# apply
MUL temp, temp.yyyy, temp.zzzz;
MUL temp, temp, lights[$colori];
ADD totcol, totcol, temp;
";

}

print FIL "

MUL result.color, totcol, diffuse;
#MAD result.color, norm_world, {0.5, 0.5, 0.5, 0.0}, {0.5, 0.5, 0.5, 1.0};
DP4 result.position.x, pos_obj, mvp[0];
DP4 result.position.y, pos_obj, mvp[1];
DP4 result.position.z, pos_obj, mvp[2];
DP4 result.position.w, pos_obj, mvp[3];
MOV	result.texcoord[0], vertex.attrib[8];
MOV	result.texcoord[1], vertex.attrib[9];

END
";





close FIL;

}
